/*====================================================================
| Version: November 11, 2010
\===================================================================*/

/*====================================================================
| Ricard Delgado-Gonzalo
| EPFL/STI/IOA/LIB/BM.4.141
| e-mail: ricard.delgado@gmail.com
| URL: http://www.ricarddelgado.com/
\===================================================================*/
package analysis;

import java.awt.geom.Point2D;
import java.util.Vector;

public class CTMelkman {
	private Vector<Point2D.Double> inputPoints 	= null;
	private Vector<Point2D.Double> outputPoints	= null;
	private Point2D.Double[] D 					= null;
	private int n, top, bot;
	
	CTMelkman(Vector<Point2D.Double> input){
		n = input.size();
		D = new Point2D.Double[2*n+1];
		inputPoints = input;
		outputPoints = new Vector<Point2D.Double>();
		bot = n-2;
		top = bot+3;
		D[bot] = D[top] = inputPoints.elementAt(2);
		
		if(IsLeft(inputPoints.elementAt(0), inputPoints.elementAt(1), inputPoints.elementAt(2))>=0){
			D[bot+1] = inputPoints.elementAt(0);
			D[bot+2] = inputPoints.elementAt(1);
		}else{
			D[bot+1] = inputPoints.elementAt(1);
			D[bot+2] = inputPoints.elementAt(0);
		}
		
		for(int i=3; i<n; i++){
			if((IsLeft(D[bot],D[bot+1],inputPoints.elementAt(i))>=0)&&(IsLeft(D[top-1],D[top],inputPoints.elementAt(i))>=0)){
				continue;
			}
			while (IsLeft(D[bot], D[bot+1], inputPoints.elementAt(i))<0){
				bot++;                
			}
			bot--;
			D[bot] = inputPoints.elementAt(i);

	        while (IsLeft(D[top-1], D[top], inputPoints.elementAt(i))<0){
				top--;  
	        }
	        top++;
	        D[top] = inputPoints.elementAt(i);
		}
		
		for(int h=0; h<= (top-bot); h++){
			outputPoints.add(D[bot+h]);
		}
	}
	
	public Vector<Point2D.Double> getOutputPoints(){
		return outputPoints;
	}
	
	private double IsLeft(Point2D.Double p0, Point2D.Double p1, Point2D.Double p2 ) {
		return (p1.x-p0.x)*(p2.y-p0.y)-(p2.x-p0.x)*(p1.y-p0.y);
	}


}
