/*====================================================================
| Version: November 11, 2010
\===================================================================*/

/*====================================================================
| Ricard Delgado-Gonzalo
| EPFL/STI/IOA/LIB/BM.4.141
| e-mail: ricard.delgado@gmail.com
| URL: http://www.ricarddelgado.com/
\===================================================================*/
package display;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.util.Vector;

import javax.swing.JFrame;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.LegendItem;
import org.jfree.chart.LegendItemCollection;
import org.jfree.chart.plot.Plot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.DeviationRenderer;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYIntervalSeries;
import org.jfree.data.xy.XYIntervalSeriesCollection;

@SuppressWarnings("serial")
public class CTLinesDeviationChart extends JFrame {
	
	private static Color[] colorArray = {Color.red, Color.yellow, Color.blue, Color.green, Color.cyan};
	
	public CTLinesDeviationChart(String applicationTitle, String axis, Vector<Point2D.Double>[] data, Vector<Point2D.Double>[] std, String[] legend) {
        super(applicationTitle);
        if(legend.length > 5) return;
        XYDataset dataSet = getData(data, std);
        JFreeChart chart = ChartFactory.createXYLineChart(null,"Frame",axis,dataSet,PlotOrientation.VERTICAL,false,false,false);
        XYPlot plot = (XYPlot) chart.getPlot();
        DeviationRenderer renderer = new DeviationRenderer();
        for(int i=0; i<data.length; i++){
            renderer.setSeriesLinesVisible(i, true);
            renderer.setSeriesShapesVisible(i, true);
            renderer.setSeriesPaint(i, colorArray[i]);
            renderer.setSeriesFillPaint(i, colorArray[i]); 
        }
        plot.setRenderer(renderer);
        plot.setFixedLegendItems(createLegendItems(legend));
        final ChartPanel chartPanel = new ChartPanel(chart);
        setContentPane(chartPanel);
    }
    
    private static XYDataset getData(Vector<Point2D.Double>[] data, Vector<Point2D.Double>[] std) {
    	XYIntervalSeriesCollection dataSet = new XYIntervalSeriesCollection();
   	 	for(int k=0; k<data.length; k++){
        	int length = data[k].size();
        	XYIntervalSeries series = new XYIntervalSeries("");
           	for(int i=0; i<length; i++){
    	        series.add(data[k].elementAt(i).x,data[k].elementAt(i).x, data[k].elementAt(i).x, data[k].elementAt(i).y, data[k].elementAt(i).y-std[k].elementAt(i).y, data[k].elementAt(i).y+std[k].elementAt(i).y);
    		}
    		
            dataSet.addSeries(series);
    	}
        return dataSet;
	}
    
    private static LegendItemCollection createLegendItems(String[] legend) {
    	int nLabels = legend.length;
    	LegendItemCollection legenditemcollection = new LegendItemCollection();
    	for(int i=0; i<nLabels; i++){
        	LegendItem legenditem  = new LegendItem(legend[i], "-", null, null, Plot.DEFAULT_LEGEND_ITEM_BOX, colorArray[i]);
        	legenditemcollection.add(legenditem);
    	}
    	return legenditemcollection;
   	}
}