/*====================================================================
| Version: November 11, 2010
\===================================================================*/

/*====================================================================
| Ricard Delgado-Gonzalo
| EPFL/STI/IOA/LIB/BM.4.141
| e-mail: ricard.delgado@gmail.com
| URL: http://www.ricarddelgado.com/
\===================================================================*/
package display;
import java.awt.Color;

import javax.swing.JFrame;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.LegendItem;
import org.jfree.chart.LegendItemCollection;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.Plot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.GroupedStackedBarRenderer;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;


@SuppressWarnings("serial")
public class CTStackedBarChart extends JFrame {

	
	private static Color[] colorArray = {Color.red, Color.yellow, Color.blue, Color.green, Color.cyan};
	
	public CTStackedBarChart(String applicationTitle, int[][] data, String[] legend) {
        super(applicationTitle);
        if(legend.length > 5) return;
        CategoryDataset dataset = getData(data);
        JFreeChart chart = createChart(dataset, legend);
        ChartPanel chartPanel = new ChartPanel(chart);
        setContentPane(chartPanel);
    }
    
	private static CategoryDataset getData(int[][] data) {
		DefaultCategoryDataset dataSet = new DefaultCategoryDataset();
		int nElements = data.length;
		int nClasses = data[0].length;
		for(int i=0; i<nClasses; i++){
			for(int j=0; j<nElements; j++){
				dataSet.addValue(data[j][i], ""+j, ""+(i+1));
			}
		}
		return dataSet;
	}
    
    private static JFreeChart createChart(CategoryDataset categorydataset, String[] legend) {
    	JFreeChart jfreechart = ChartFactory.createStackedBarChart(null, "Frame", "Count", categorydataset, PlotOrientation.VERTICAL, true, true, false);
    	GroupedStackedBarRenderer renderer = new GroupedStackedBarRenderer();
    	renderer.setItemMargin(0.01);
    	renderer.setDrawBarOutline(false);
    	for(int i=0; i<legend.length; i++){
    		renderer.setSeriesPaint(i, colorArray[i]);
        }
    	CategoryPlot categoryplot = (CategoryPlot) jfreechart.getPlot();
    	categoryplot.setRenderer(renderer);
    	categoryplot.setFixedLegendItems(createLegendItems(legend));
    	return jfreechart;
    	}
    
    private static LegendItemCollection createLegendItems(String[] legend) {
    	int nLabels = legend.length;
    	LegendItemCollection legenditemcollection = new LegendItemCollection();
    	for(int i=0; i<nLabels; i++){
        	LegendItem legenditem  = new LegendItem(legend[i], "-", null, null, Plot.DEFAULT_LEGEND_ITEM_BOX, colorArray[i]);
        	legenditemcollection.add(legenditem);
    	}
    	return legenditemcollection;
   	}
}