/*====================================================================
| Version: November 11, 2010
\===================================================================*/

/*====================================================================
| Ricard Delgado-Gonzalo
| EPFL/STI/IOA/LIB/BM.4.141
| e-mail: ricard.delgado@gmail.com
| URL: http://www.ricarddelgado.com/
\===================================================================*/
package display;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.util.Vector;

import javax.swing.JFrame;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;


@SuppressWarnings("serial")
public class XYLineChart extends JFrame {

	public XYLineChart(String applicationTitle, String axis, Color color, Vector<Point2D.Double> data) {
        super(applicationTitle);
        XYDataset dataSet = getData(data);
        JFreeChart chart = ChartFactory.createXYLineChart(null,"Frame",axis,dataSet,PlotOrientation.VERTICAL,false,false,false);
        XYPlot plot = (XYPlot) chart.getPlot();
        XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
        renderer.setSeriesLinesVisible(0, true);
        renderer.setSeriesShapesVisible(0, true);
        renderer.setSeriesPaint(0, color);
        plot.setRenderer(renderer);
        final ChartPanel chartPanel = new ChartPanel(chart);
        setContentPane(chartPanel);
    }
    
    private static XYDataset getData(Vector<Point2D.Double> data) {
		XYSeries series = new XYSeries("");
		int length = data.size();
		for(int i=0; i<length; i++){
	        series.add(data.elementAt(i).x, data.elementAt(i).y);
		}
		
        XYSeriesCollection dataSet = new XYSeriesCollection();
        dataSet.addSeries(series);
        return dataSet;
	}
}